﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace University_Code_Stage_I
{
    public class Student
    {
        public string Name { get; set; }
        public bool HasDegree { get; set; }

        private Semester activeSemester;
        public NEPTUNSystem System { private get; set; }

        public void StartSemester(Semester se)
        {
            if (this.System == null)
                throw new Exception("Student must be registered in the NEPTUN system!");

            // Ha fel tudjuk venni az aktív félévet, felvesszük
            if (System.StartActiveSemester(this, se))
            {
                this.activeSemester = se;
                Console.WriteLine("###STUDENT### " + this.Name + " started an active semester ");
            }
        }

        public void EndSemester()
        {
            if (activeSemester == null)
                throw new Exception("Cannot end semester as there is no active semester!");

            // Az aktív félév befejezésekor a NEPTUN rendszer még bejegyzi a teljesített tárgyakat
            this.System.EndActiveSemester(this, this.activeSemester);
            this.activeSemester = null;

            Console.WriteLine("###STUDENT### " + this.Name + " ended the active semester ");
        }

        public void RequestDegree()
        {
            // A diploma kiadását a hallgató kérvényezi
            if (this.System.RequestDegree(this))
                HasDegree = true;
        }
    }
}
